10 rem $$chan=4
11 rem $$stak=9216
12 :
13 rem + ######################################################################## +
14 rem #<                                 SBBox                                  >#
15 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
16 rem #           Utility to make header boxes for S*BASIC procedures            #
17 rem #                                                                          #
18 rem # See my Style Guide for details of usage, including how to put on a       #
19 rem # Hotkey                                                                   #
20 rem #                                                                          #
21 rem #                                                                          #
22 rem + ------------------------------------------------------------------------ +
23 rem # V0.01, pjw, 2015 Feb 05                                                  #
24 rem # V0.04, pjw, 2018 Apr 06, Re-write free of dependencies, sig on CMD$      #
25 rem + ######################################################################## +
26 :
27 :
28 fnm$     = 'ram1_' & HEX$(JOBID, 32) & '_sbx':  rem temp file
29 sig$     = CMD$:                                rem Author's initials
30 if sig$  = '': sig$ = '???'
31 ll%      = 76:                                  rem Line length
32 lf$      = CHR$(10):                            rem Linefeed
33 first    = 0:                                   rem Scrap's first line
34 special$ = '-=+*#':                             rem Special chars
35 dt$      = date$:                               rem Today
36 :
37 :
38 ch = FOP_OVER(fnm$)
39 BPUT#ch; SCRAP_GET$, 10: CLOSE#ch:              rem Empty Scrap into temp
40 rem BPUT#ch; SCRAP_GET$: CLOSE#ch:  rem Empty Scrap into temp (SBASIC)
41 :
42 ch = fop_in(fnm$): if ch < 0: Burp: quit
43 fl = flen(#ch)
44 if fl = 0: Burp: quit
45 fl = fl - 1:                                    rem QLib needs final lf
46 :
47 rem     Box horisontal char is first char
48 c1$ = inkey$(#ch; 0)
49 c1% = c1$ instr special$
50 if c1% = 0 then
51  get#ch\ 0:                                     rem Start from begining
52  c1$ = '-'
53  c1% = 1
54 end if
55 :
56 rem     Special horizontal char for sections
57 IF c1% > 3: ch$ = c1$: ELSE : ch$ = '|'
58 :
59 Putl '+', c1$:                                  rem Top row
60 input#ch; l$
61 Putc ch$ & '<', l$, '>' & ch$:                  rem Title
62 Putl '+', '~':                                  rem End title row
63 input#ch; l$
64 Putc ch$, l$, ch$:                              rem Brief description
65 Putx '':                                        rem Blank row
66 :
67 ll$ = '':                                       rem Line to wrap and print
68 rep lp
69  if eof(#ch): exit lp
70  input#ch; l$
71  rem Look for blank lines, new lines, and specials
72  if len(l$) = 0 or len(l$) = 1 then
73   if len(l$) = 1 then
74    s% = l$ instr special$
75   else
76    if fpos(#ch) >= fl: exit lp:                 rem QLIB: Final LF reached
77    s% = 5
78   endif
79   :
80   rem Blank or draw a line?
81   If len(ll$): Wrap ' ', ll% - 6, ll$:          rem Finish previous first
82   if s% = 5 then
83    Putx '':                                     rem Blank
84   else
85    if s% > 0 then
86     Putl '+', special$(s%):                     rem Draw line
87    else
88     Putx l$:                                    rem Some lonely character..
89    endif
90   endif
91   ll$ = ''
92  else
93   rem Start fresh line?
94   if ('#' instr l$) = 1 then
95    Wrap ' ', ll% - 6, ll$:                      rem Yes, fresh line
96    ll$ = l$(2 to len(l$))
97   else
98    if len(ll$): ll$ = ll$ & ' ':                rem Continuation
99    ll$ = ll$ & l$
100   endif
101  endif
102 endrep lp
103 close#ch
104 if len(ll$): Wrap ' ', ll% - 6, ll$:            rem Last line
105 :
106 rem     Finalise
107 Putl '+', '-'
108 Putx 'V0.01, ' & sig$ & ', ' & dt$(1 to 11)
109 Putl '+', c1$
110 :
111 if c1% = 5: c1% = 4:                            rem c5 and c4 are same level
112 for i% = 1 to c1% - 1: scrap_put 0, ':' & lf$, first
113 scrap_put 0, ':', first
114 delete fnm$
115 :
116 Ping:                                           rem All swell!
117 :
118 :
119 rem + ------------------------------------------------------------------------ +
120 rem |<                                  Putl                                  >|
121 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
122 rem |                         Output a horizontal line                         |
123 rem |                                                                          |
124 rem | This routine initialises Scrap, if first set to 0 fl$ is the first and   |
125 rem | last char, cl$ is the line character                                     |
126 rem | GLOBal lf$, ll%                                                          |
127 rem + ------------------------------------------------------------------------ +
128 rem | V0.01, pjw, 2018 Apr 06                                                  |
129 rem + ------------------------------------------------------------------------ +
130 :
131 DEFine PROCedure Putl(fl$, cl$)
132 SCRAP_PUT 0, 'rem ' & fl$ & ' ' & FILL$(cl$, ll% - 4) & ' ' & fl$ & lf$, first
133 first = 1:                      rem Tell Scrap we want to add hereafter
134 END DEFine Putl
135 :
136 :
137 rem + ------------------------------------------------------------------------ +
138 rem |<                                  Putc                                  >|
139 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
140 rem |                     Output a line with centred text                      |
141 rem |                                                                          |
142 rem | fc$ = first chars, lc$ = last chars, with text in the middle             |
143 rem | The text is truncated (if need be)                                       |
144 rem | GLOBal lf$, ll%                                                          |
145 rem + ------------------------------------------------------------------------ +
146 rem | V0.01, pjw, 2018 Apr 06                                                  |
147 rem + ------------------------------------------------------------------------ +
148 :
149 DEFine PROCedure Putc(fc$, tx$, lc$)
150 loc t$, l%
151 l% = ll% - len(fc$) - len(lc$) - 2
152 if len(tx$) > l%: t$ = tx$(1 to l%): else: t$ = tx$
153 SCRAP_PUT 0, 'rem ' & fc$ & ' ' & Centre$(t$, l%) & ' ' & lc$ & lf$, first
154 END DEFine Putc
155 :
156 :
157 rem + ------------------------------------------------------------------------ +
158 rem |<                                  Putx                                  >|
159 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
160 rem |                          Output a line of text                           |
161 rem |                                                                          |
162 rem + ------------------------------------------------------------------------ +
163 rem | V0.01, pjw, 2018 Apr 06                                                  |
164 rem + ------------------------------------------------------------------------ +
165 :
166 DEFine PROCedure Putx(tx$)
167 SCRAP_PUT 0, 'rem ' & ch$ & ' ' & tx$ & fill$(' ', ll% - len(tx$) - 3) & ch$ & lf$, first
168 END DEFine Putx
169 :
170 :
171 rem + ------------------------------------------------------------------------ +
172 rem |<                                 Centre                                 >|
173 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
174 rem |            Centre a line of text within the given line length            |
175 rem |                                                                          |
176 rem | This routine padds the other side of the cetred string too               |
177 rem + ------------------------------------------------------------------------ +
178 rem | V0.01, pjw, 2018 Apr 06                                                  |
179 rem + ------------------------------------------------------------------------ +
180 :
181 DEFine FuNction Centre$(tx$, ll%)
182 RETurn FILL$(" ", (ll% - LEN(tx$)) div 2) & tx$ & FILL$(' ', (ll% - LEN(tx$)) / 2)
183 END DEFine Centre$
184 :
185 :
186 rem + ------------------------------------------------------------------------ +
187 rem |<                                  Wrap                                  >|
188 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
189 rem | Split long lines at given width                                          |
190 rem |                                                                          |
191 rem | Split at <space> and/or some other designated split character            |
192 rem | This version works on a character-by-character basis                     |
193 rem + ------------------------------------------------------------------------ +
194 rem | V0.02c, pjw, February 19th 2017, Complete re-write                       |
195 rem + ------------------------------------------------------------------------ +
196 :
197 DEFine PROCedure Wrap(p$, w%, t$)
198 LOCal i%, p%, e%, l$
199 :
200 l$ = '': p% = 0: e% = LEN(t$)
201 FOR i% = 1 TO e%
202  IF p% > w% THEN
203   Putx l$(1 TO e% - 1)
204   IF e% = LEN(l$) THEN
205    l$ = t$(i%)
206   ELSE
207    l$ = l$(e% + 1 TO LEN(l$)) & t$(i%)
208   END IF
209   e% = LEN(l$)
210   p% = e% + 1
211  ELSE
212   p% = p% + 1
213   l$ = l$ & t$(i%)
214  END IF
215  IF t$(i%) INSTR p$: e% = LEN(l$)
216 END FOR i%
217 Putx l$
218 END DEFine Wrap
219 :
220 :
221 def proc Burp: beep 9999, 255: enddef Burp
222 def proc Ping: beep 2000, 1: enddef Ping
223 :
224 :
